;	Converts the Altirra write events to linear color tables ($900) bytes
;	Run final image in Altirra
;	Enter Debugger
;	bx "write>=$d012 and write<=$d01a" ".printf (%3d,%3d):%y=$%02x vpos hpos address value ; g"
;	Use the gs or gf commands to step by a frame.
;	Copy the result to clip board
;	Sort text.
;	Remove all lines which are not color writes
;	( 44,107):COLPF1=$1e
;	( 47,108):COLPF2=$2a
;	( 67,107):COLPF2=$0c
;	Use search and replace to transform them into
;		.byte 44,107,COLPF1,$1e
;		.byte 47,108,COLPF2,$2a
;		.byte 67,107,COLPF2,$0c
;	Put them into "ExtractColors.asm" and continue there.
;	write 4000 48ff C:\jac\system\Atari800\Programming\Demos\SillyPack2k12\atr\fix\GFX\Flame\ExtractColors.col

colbase	= $4000
col	= >colbase
colbk	= col+0
colpf0	= col+1
colpf1	= col+2
colpf2	= col+3
colpf3	= col+4
colpm0	= col+5 
colpm1	= col+6
colpm2	= col+7
colpm3	= col+8

p1	 = $80
line_cnt = $e0
last_line= $e1

	org $2000

	.proc main
	jsr pre_process
	mwa #export p1
	mva #0 line_cnt
loop	ldy #0
	lda (p1),y
	sta last_line
	beq done
	cmp line_cnt
	bne next_line

	ldy #2
	lda (p1),y
	sec
	sbc #col
	tax
	iny
	lda (p1),y
	sta current_colors,x
	adw p1 #4
	jmp loop
	
next_line
	jsr copy_line
	inc line_cnt
	jmp loop


done	jsr fill_lines
	.byte 2
	.endp

	.proc pre_process
	mwa #export p1
loop	ldy #0
	lda (p1),y
	sta last_line
	beq done
	iny
	lda (p1),y
	cmp #70		;Changes on the right half count for the next line
	bcc no_inc
	ldy #0
	lda last_line
	add #1
	sta (p1),y

no_inc	adw p1 #4
	jmp loop
done	rts
	.endp
	
;===============================================================

	.proc copy_line
	ldy line_cnt
	ldx #8
loop	lda color_his,x
	sta sta_adr+1
	lda current_colors,x
sta_adr	= *+1
	sta colbase,y
	dex
	bpl loop
	rts
	.endp

;===============================================================

	.proc fill_lines
	ldy #0
loop_y	ldx #8
loop_x	lda color_his,x
	sta lda_adr+1
	sta sta_adr+1

lda_adr	= *+1
	lda colbase,y
	cmp #$ff
	bne already_filled

	lda current_colors,x
sta_adr	= *+1
	sta colbase,y

already_filled
	dex
	bpl loop_x
	iny
	cpy last_line
	bne loop_y
	rts
	.endp

;===============================================================


	.local current_colors
	.byte $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	.endl

	.local color_his
	.byte colbk,colpf0,colpf1,colpf2,colpf3,colpm0,colpm1,colpm2,colpm3
	.endl

;===============================================================

	.local export
	.byte 44,107,COLPF1,$1e
	.byte 44,107,COLPF1,$1e
	.byte 47,108,COLPF2,$2a
	.byte 67,107,COLPF2,$0c
	.byte 67,111,COLPF3,$12
	.byte 68,107,COLPF3,$f2
	.byte 70,107,COLPF3,$12
	.byte 71,107,COLPF3,$f2
	.byte 71,111,COLPM0,$1a
	.byte 72,107,COLPF3,$12
	.byte 73,108,COLPF3,$f2
	.byte 74,108,COLPF3,$12
	.byte 76,107,COLPF3,$f2
	.byte 77,107,COLPF3,$12
	.byte 80,107,COLPM2,$7a
	.byte 90,107,COLPF2,$1c
	.byte 91,12,COLPM1,$0e
	.byte 91,107,COLPF2,$0c
	.byte 94,107,COLPF2,$1c
	.byte 95,111,COLPF2,$0c
	.byte 97,107,COLPF2,$1c
	.byte 98,108,COLPF2,$0c
	.byte 99,108,COLPF2,$1c
	.byte 100,107,COLPF2,$0c
	.byte 100,111,COLPF3,$22
	.byte 101,12,COLPM3,$18
	.byte 101,108,COLPF2,$1c
	.byte 101,112,COLPF3,$12
	.byte 103,107,COLPF2,$0c
	.byte 103,111,COLPF3,$22
	.byte 104,107,COLPF2,$1c
	.byte 104,111,COLPF3,$12
	.byte 105,107,COLPF3,$22
	.byte 106,108,COLPF3,$12
	.byte 107,107,COLPF2,$0c
	.byte 107,111,COLPF3,$22
	.byte 108,107,COLPF2,$1c
	.byte 109,108,COLPF3,$12
	.byte 110,108,COLPF3,$22
	.byte 111,108,COLPM3,$16
	.byte 115,107,COLPF2,$2a
	.byte 115,111,COLPM3,$18
	.byte 116,107,COLPF2,$1c
	.byte 118,107,COLPF1,$0c
	.byte 119,107,COLPF1,$1e
	.byte 119,111,COLPF2,$2a
	.byte 120,107,COLPF2,$1c
	.byte 121,108,COLPF1,$0c
	.byte 122,107,COLPF1,$1e
	.byte 122,111,COLPF2,$2a
	.byte 123,10,COLPM3,$7a
	.byte 123,107,COLPF1,$0c
	.byte 123,111,COLPF2,$1c
	.byte 124,107,COLPF1,$1e
	.byte 124,111,COLPF2,$2a
	.byte 126,6,COLPM2,$0e
	.byte 126,107,COLPF1,$0c
	.byte 126,111,COLPF2,$1c
	.byte 127,111,COLPF2,$2a
	.byte 128,107,COLPM0,$1c
	.byte 130,107,COLPF2,$1c
	.byte 131,108,COLPF2,$2a
	.byte 137,6,COLPM3,$20
	.byte 138,107,COLPF2,$28
	.byte 139,108,COLPF2,$2a
	.byte 142,108,COLPF2,$28
	.byte 143,108,COLPF2,$2a
	.byte 145,107,COLPF2,$28
	.byte 146,108,COLPF2,$2a
	.byte 147,107,COLPF2,$28
	.byte 148,107,COLPF2,$2a
	.byte 149,107,COLPF1,$1e
	.byte 150,10,COLPM3,$7a
	.byte 150,107,COLPF2,$28
	.byte 151,111,COLPF2,$2a
	.byte 152,107,COLPF2,$28
	.byte 153,107,COLPF1,$1c
	.byte 153,111,COLPF3,$12
	.byte 154,107,COLPF1,$1e
	.byte 154,111,COLPF3,$22
	.byte 155,107,COLPF2,$2a
	.byte 156,107,COLPF1,$1c
	.byte 156,111,COLPF2,$28
	.byte 157,6,COLPF3,$12
	.byte 157,107,COLPF3,$22
	.byte 158,107,COLPF1,$1e
	.byte 158,111,COLPF3,$12
	.byte 159,107,COLPF1,$1c
	.byte 159,111,COLPF3,$22
	.byte 160,107,COLPF3,$12
	.byte 162,107,COLPF3,$22
	.byte 163,107,COLPF1,$1a
	.byte 163,111,COLPF3,$12
	.byte 164,108,COLPF1,$1c
	.byte 164,112,COLPF2,$26
	.byte 165,107,COLPF2,$28
	.byte 166,108,COLPF1,$1a
	.byte 167,107,COLPF1,$1c
	.byte 167,111,COLPF2,$26
	.byte 168,107,COLPF1,$1a
	.byte 169,107,COLPF1,$1c
	.byte 169,111,COLPF2,$28
	.byte 170,107,COLPF1,$1a
	.byte 170,111,COLPF2,$26
	.byte 171,107,COLPF2,$28
	.byte 172,107,COLPF1,$1c
	.byte 172,111,COLPF2,$26
	.byte 173,107,COLPF1,$1a
	.byte 174,107,COLPF2,$28
	.byte 175,111,COLPF2,$26
	.byte 178,107,COLPF2,$28
	.byte 179,108,COLPF2,$26
	.byte 181,107,COLPF3,$f2
	.byte 182,108,COLPF3,$12
	.byte 184,107,COLPF3,$f2
	.byte 185,107,COLPF3,$12
	.byte 186,108,COLPF3,$f2
	.byte 187,108,COLPF3,$12
	.byte 188,108,COLPF3,$f2
	.byte 189,107,COLPF1,$1e
	.byte 189,111,COLPF2,$2a
	.byte 190,107,COLPF3,$12
	.byte 191,108,COLPF3,$f2
	.byte 200,107,COLPF1,$0a
	.byte 209,107,COLPF1,$7a
	.byte 210,107,COLPF1,$0a
	.byte 212,107,COLPF1,$7a
	.byte 213,108,COLPF1,$0a
	.byte 214,108,COLPF1,$7a
	.byte 220,107,COLPF1,$8a
	.byte 221,108,COLPF1,$7a
	.byte 223,112,COLPF1,$8a
	.byte 224,107,COLPF1,$7a
	.byte 225,108,COLPF1,$8a
	.byte 226,108,COLPF1,$7a
	.byte 227,108,COLPF1,$8a
	.byte 248,82,COLBK,$00
	.byte 248,88,COLPF0,$06
	.byte 248,94,COLPF1,$8c
	.byte 248,100,COLPF2,$76
	.byte 248,106,COLPF3,$f2
	.byte 249,16,COLPM0,$1c
	.byte 249,38,COLPM3,$0e
	.byte 249,67,COLPM1,$12
	.byte 249,85,COLPM2,$22
	.endl
	.byte 0

	run main